<?php

// 01. URL de l'environnement à appeler (TEST ou PRODUCTION)
define('API_ENDPOINT', 'https://stage-secure-gateway.hipay-tpp.com/rest/v1'); // TEST
// define('API_ENDPOINT', 'https://secure-gateway.hipay-tpp.com/rest/v1'); // PRODUCTION


// 02. Identifiant API du compte HiPay pour s'authentifier auprès de l'API HiPay
define('API_USERNAME', $_POST['user']);
define('API_PASSWORD', $_POST['pwd']);


// 03. Création des 2 variables pour stocker les infos sur l'environnement, l'API et les identifiants API
$resource = API_ENDPOINT . '/hpayment';
$credentials = API_USERNAME . ':' . API_PASSWORD;



// 04. Construction de la requête
$request = array(
// 1. Design et paramétrage de la page
'template' =>$_POST['template'],
'time_to_limit_to_pay' =>'',
'css' =>'',
'language' =>'fr_FR',
'merchant_display_name' =>'',
'orderid'=>$_POST['orderid'],
'display_selector'=>'1',
'payment_product_category_list'=>'credit-card','debit-card', // facultatif
'payment_product_list'=>'visa,mastercard,cb,american-express,maestro,carte-cadeau', //facultatif

// 2. Paramètrge du paiement
'operation'=> 'Authorization',
'eci'=> '7',
'multi_use'=>'',
'description'=> 'produit test 01',
'long_description'=> 'produit test 01',
'authentication_indicator'=>'1',
'currency'=> 'EUR',
'amount'=> $_POST['amount'],
'shipping'=> 10,
'tax'=> 10,
'tax_rate'=> 5,
'custom_data' =>
'{
	"shipping_method":"click and collect",
	"first_order":"0",
	"products_list":"First product, Second product, Third product",
	"_reporting_data_1":"my custom data 1"}',

	// 3. Informations du client
	'email'=> 'toto@gmail.com',
	'phone'=> '',
	'birthdate'=> '',
	'gender'=> '',
	'firstname'=> '',
	'lastname'=> '',
	'country'=> '',
	'streetaddress'=> '',
	'streetaddress2'=> '',
	'city'=> '',
	'zipcode'=> '',
	'shipto_firstname'=> '',
	'shipto_lastname'=> '',
	'shipto_streetaddress'=> '',
	'shipto_streetaddress2'=> '',
	'shipto_city'=> '',
	'shipto_zipcode'=> '',
	'shipto_country'=> '',
	'cid'=> '123456',
	'ipaddr'=> '',
	'accept_url'=> 'https://image.freepik.com/free-vector/card-template-with-fireworks-party-horns_1308-3021.jpg',
	'decline_url'=> 'https://previews.123rf.com/images/aquir/aquir1311/aquir131100094/23420980-failed-red-grunge-stamp.jpg',
	'pending_url'=> '',
	'exception_url'=> '',
	'cancel_url'=> ''
	);


// 05. Initialisation de cURL
$curl = curl_init();

// 07. Définition des en-têtes
$header = array(
  'User-Agent: ' .$_SERVER['HTTP_USER_AGENT'],
  'Accept: application/json',
  'Accept-Language: ' . $_SERVER['HTTP_ACCEPT_LANGUAGE']
);

// 07. Configuration des options de cURL
$options = array(
	CURLOPT_URL => $resource,
	CURLOPT_USERPWD => $credentials,
	CURLOPT_HTTPHEADER => $header,
	CURLOPT_RETURNTRANSFER =>true,
	CURLOPT_FAILONERROR => false,
	CURLOPT_HEADER =>false,
	CURLOPT_POST => true,
	CURLOPT_POSTFIELDS => $request
);


foreach ($options as $option => $value) {
	curl_setopt($curl, $option, $value);
}

// 08. Exécution de cURL
if (false === ($result = curl_exec($curl))) {
	echo "<br/><strong>Error: </strong><br/>";
	var_dump(curl_error($curl), curl_errno($curl));
	exit();
}

$status = (int)curl_getinfo($curl, CURLINFO_HTTP_CODE);

// 09. Affichage de la réponse API
$response = json_decode($result);
var_dump($response);
$url = $response->forwardUrl;

 // 10. Deconnexion de cURL
curl_close($curl);

// 11. Afficher le bouton "Payer"
if ($_POST['template'] == "iframe-js")
{
	echo "<br/><iframe src='".$url."' target='_blank' width='600' height='800' margin='auto'>Payer par carte</iframe>";
	
}
else {
	echo "<br/><a href='".$url."' target='_blank'>Payer par carte</a>";
}
?>


