<?php

// 01. URL de l'environnement à appeler (TEST ou PRODUCTION)
$env = substr($_POST['pwd'], 0, 4); 
if ($env == "Live") {
	define('API_ENDPOINT', 'https://secure-gateway.hipay-tpp.com/rest/v1'); // PRODUCTION
}
else define('API_ENDPOINT', 'https://stage-secure-gateway.hipay-tpp.com/rest/v1'); // TEST


// 02. Identifiant API du compte HiPay pour s'authentifier auprès de l'API HiPay
define('API_USERNAME', $_POST['user']);
define('API_PASSWORD', $_POST['pwd']);


// 03. Création des 2 variables pour stocker les infos sur l'environnement, l'API et les identifiants API
$resource = API_ENDPOINT . '/hpayment';
$credentials = API_USERNAME . ':' . API_PASSWORD;



// 04. Construction de la requête
$request = array(
// 1. Design et paramétrage de la page
'template' =>$_POST['template'],
'time_to_limit_to_pay' =>'',
'css' =>'',
'language' =>'fr_FR',
'merchant_display_name' =>'',
'orderid'=>'test'.$_POST['orderid'],
'display_selector'=>'1',
//'payment_product_category_list'=>'credit-card, debit-card, realtime-banking, ewallet', // facultatif
//'payment_product_list'=>'visa, mastercard, maestro, cb, 3xcb, 3xcb-no-fees, 4xcb, 4xcb-no-fees, american-express, bank-transfer, bcmc, bcmc-mobile, cbc-online, dexia-directnet, giropay, ideal, ing-homepay, kbc-online, klarnainvoice, paypal, paysafecard, payulatam, przelewy24, qiwi-wallet, sdd, sisal, sofort-uberweisung', //facultatif
//'payment_product'=>'visa',

// 2. Paramètrge du paiement
'operation'=> 'Authorization',
'eci'=> '7',
'multi_use'=>'',
'description'=> 'produit test 01',
'long_description'=> 'produit test 01',
'authentication_indicator'=>'1',
'currency'=> $_POST['devise'],
'amount'=> $_POST['amount'],
'shipping'=> 10,
'tax'=> 10,
'tax_rate'=> 5,

'custom_data' =>
'{
	"shipping_method":"click and collect",
	"first_order":"0",
	"products_list":"First product, Second product, Third product",
	"_reporting_data_1":"my custom data 1"}',

	// 3. Informations du client
	'email'=> 'test.hpayment@hipay.com',
	'phone'=> '0123456789',
	'birthdate'=> '',
	'gender'=> 'U',
	'firstname'=> 'Martine',
	'lastname'=> 'Durand',
	'country'=> 'FR',
	'streetaddress'=> '34 avenue de Flandre',
	'streetaddress2'=> '',
	'city'=> 'Croix',
	'zipcode'=> '59170',
	'shipto_phone'=>'0123456789',
	'shipto_firstname'=> 'Test',
	'shipto_lastname'=> 'Hipay',
	'shipto_streetaddress'=> '100 avenue du Parc Barbieux',
	'shipto_streetaddress2'=> '',
	'shipto_city'=> 'Croix',
	'shipto_zipcode'=> '59170',
	'shipto_country'=> 'FR',
	'cid'=> '123456',
	'ipaddr'=> '',
	'accept_url'=> 'https://developer.hipay.com/simulator/success/',
	'decline_url'=> 'https://developer.hipay.com/simulator/decline/',
	'pending_url'=> 'https://developer.hipay.com/simulator/pending/',
	'exception_url'=> 'https://developer.hipay.com/simulator/exception/',
	'cancel_url'=> 'https://developer.hipay.com/simulator/cancel/',
	'order_category_code'=>'5261',
	'delivery_date'=>'2019-12-21',
	'delivery_method'=>'{"mode":"STORE","shipping":"STANDARD"}',
//	'delivery_method'=>'{"mode":"TRAVEL","shipping":"EXPRESS"}',
	'carrier_description'=>'Carrier test',

	'basket'=>'[{"product_category": 8,
       "product_reference": "NF-a0351",
       "name": "My second product",
       "type": "good",
       "quantity": 1,
       "unit_price": '.$_POST['amount'].',
       "total_amount": '.$_POST['amount'].'}]'

	
	);


// 05. Initialisation de cURL
$curl = curl_init();

// 07. Définition des en-têtes
$header = array(
  'User-Agent: ' .$_SERVER['HTTP_USER_AGENT'],
  'Accept: application/json',
  'Accept-Language: ' . $_SERVER['HTTP_ACCEPT_LANGUAGE']
);

// 07. Configuration des options de cURL
$options = array(
	CURLOPT_URL => $resource,
	CURLOPT_USERPWD => $credentials,
	CURLOPT_HTTPHEADER => $header,
	CURLOPT_RETURNTRANSFER =>true,
	CURLOPT_FAILONERROR => false,
	CURLOPT_HEADER =>false,
	CURLOPT_POST => true,
	CURLOPT_POSTFIELDS => $request
);


foreach ($options as $option => $value) {
	curl_setopt($curl, $option, $value);
}

// 08. Exécution de cURL
if (false === ($result = curl_exec($curl))) {
	echo "<br/><strong>Error: </strong><br/>";
	var_dump(curl_error($curl), curl_errno($curl));
	exit();
}

$status = (int)curl_getinfo($curl, CURLINFO_HTTP_CODE);

// 09. Affichage de la réponse API
$response = json_decode($result);
var_dump($response);
$url = $response->forwardUrl;

 // 10. Deconnexion de cURL
curl_close($curl);

// 11. Afficher le bouton "Payer"
if ($_POST['template'] == "iframe-js")
{
	echo "<br/><iframe src='".$url."' target='_blank' width='600' height='800' margin='auto'>Payer par carte</iframe>";
	
}
else {
	echo "<br/><a href='".$url."' target='_blank'>Payer par carte</a>";
}
?>


